## merlin 0.0.1

=== DESCRIPTION ===
Package: merlin
Date: 2018-08-15
Version: 0.0.1
Title: Mixed Effects Regression for Linear, Non-Linear and User-Defined
        Models
Description: Fits linear, non-linear, and user-defined mixed effects regression models following 
  the framework developed by Crowther (2017) <arXiv:1710.02223>. 'merlin' can fit multivariate 
  outcome models of any type, each of which could be repeatedly measured (longitudinal), with 
  any number of levels, and with any number of random effects at each level. Standard 
  distributions/models available include the Bernoulli, Gaussian, Poisson, beta, 
  negative-binomial, and time-to-event/survival models include the exponential, 
  Gompertz, Royston-Parmar, Weibull and general hazard model. 'merlin' provides a 
  flexible predictor syntax, allowing the user to define variables, random effects, 
  spline and fractional polynomial functions, functions of 
  other outcome models, and any interaction between each of them. Non-linear and 
  time-dependent effects are seamlessly incorporated into the predictor. 'merlin' 
  allows multivariate normal random effects, which are integrated out using Gaussian 
  quadrature or Monte-Carlo integration. Note, 'merlin' is based on the 'Stata' package 
  of the same name, described in Crowther (2018) <arXiv:1806.01615>.
Authors@R: c(
  person(given = "Emma",
         family = "Martin", 
         email = "emma.martin@le.ac.uk", 
         role = c("aut")),
  person(given = "Alessandro", 
         family = "Gasparini", 
         email = "ag475@le.ac.uk", 
         role = c("aut")),
  person(given = "Michael", 
         family = "Crowther", 
         email = "michael.crowther@le.ac.uk", 
         role = c("aut","cre"))
  )
License: GPL (>= 3)
Depends: R (>= 2.10)
Imports: statmod, stats, survival, randtoolbox, MASS
Suggests: knitr, rmarkdown, testthat
URL: https://www.mjcrowther.co.uk/software/merlin
VignetteBuilder: knitr
RoxygenNote: 6.1.0
LazyData: true
Encoding: UTF-8
ByteCompile: true
NeedsCompilation: no
Packaged: 2018-08-15 01:55:39 UTC; Michael
Author: Emma Martin [aut],
  Alessandro Gasparini [aut],
  Michael Crowther [aut, cre]
Maintainer: Michael Crowther <michael.crowther@le.ac.uk>
Repository: CRAN
Date/Publication: 2018-08-16 10:40:03 UTC

## merlin 0.0.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Package: merlin
-Date: 2018-08-15
-Version: 0.0.1
+Version: 0.0.2
 Title: Mixed Effects Regression for Linear, Non-Linear and User-Defined
         Models
 Description: Fits linear, non-linear, and user-defined mixed effects regression models following 
@@ -24,28 +23,28 @@
          role = c("aut")),
   person(given = "Alessandro", 
          family = "Gasparini", 
-         email = "ag475@le.ac.uk", 
+         email = "alessandro.gasparini@ki.se", 
          role = c("aut")),
   person(given = "Michael", 
          family = "Crowther", 
          email = "michael.crowther@le.ac.uk", 
-         role = c("aut","cre"))
+         role = c("aut", "cre"))
   )
 License: GPL (>= 3)
 Depends: R (>= 2.10)
-Imports: statmod, stats, survival, randtoolbox, MASS
-Suggests: knitr, rmarkdown, testthat
+Imports: MASS, randtoolbox, statmod, stats, survival, tools
+Suggests: knitr, nlme, rmarkdown, testthat
 URL: https://www.mjcrowther.co.uk/software/merlin
 VignetteBuilder: knitr
-RoxygenNote: 6.1.0
+RoxygenNote: 7.0.2
 LazyData: true
 Encoding: UTF-8
 ByteCompile: true
 NeedsCompilation: no
-Packaged: 2018-08-15 01:55:39 UTC; Michael
+Packaged: 2020-01-15 16:56:37 UTC; ellessenne
 Author: Emma Martin [aut],
   Alessandro Gasparini [aut],
   Michael Crowther [aut, cre]
 Maintainer: Michael Crowther <michael.crowther@le.ac.uk>
 Repository: CRAN
-Date/Publication: 2018-08-16 10:40:03 UTC
+Date/Publication: 2020-01-15 18:00:02 UTC

## merlin 0.1.0

=== DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Package: merlin
-Version: 0.0.2
+Version: 0.1.0
 Title: Mixed Effects Regression for Linear, Non-Linear and User-Defined
         Models
 Description: Fits linear, non-linear, and user-defined mixed effects regression models following 
@@ -36,15 +36,16 @@
 Suggests: knitr, nlme, rmarkdown, testthat
 URL: https://www.mjcrowther.co.uk/software/merlin
 VignetteBuilder: knitr
-RoxygenNote: 7.0.2
+RoxygenNote: 7.1.1
 LazyData: true
 Encoding: UTF-8
 ByteCompile: true
+Language: en_GB
 NeedsCompilation: no
-Packaged: 2020-01-15 16:56:37 UTC; ellessenne
+Packaged: 2020-06-29 15:06:24 UTC; ellessenne
 Author: Emma Martin [aut],
   Alessandro Gasparini [aut],
   Michael Crowther [aut, cre]
 Maintainer: Michael Crowther <michael.crowther@le.ac.uk>
 Repository: CRAN
-Date/Publication: 2020-01-15 18:00:02 UTC
+Date/Publication: 2020-06-29 17:00:03 UTC

## merlin 2.1.4

=== Makefile ===
# Merlin version
VERSION=$(shell cat pkg/merlin.go |grep "const Version ="|cut -d"\"" -f2)
BUILD=$(shell git rev-parse HEAD)

# Output File Location
DIR=data/temp/v${VERSION}/${BUILD}
$(shell mkdir -p ${DIR})

# Go build flags
LDFLAGS=-ldflags '-X github.com/Ne0nd0g/merlin/v2/pkg.Build=${BUILD} -buildid='

# Misc
# The Merlin server and agent MUST be built with the same seed value
# Set during build with "make linux-garble SEED=<insert seed>
SEED=d0d03a0ae4722535a0e1d5d0c8385ce42015511e68d960fadef4b4eaf5942feb

default:
	go build ${LDFLAGS} -o ${DIR}/${MSERVER} main.go

# Compile Server - Windows x64
windows:
	export GOOS=windows && export GOARCH=amd64 && go build ${LDFLAGS} -o ${DIR}/merlinServer-Windows-x64.exe main.go

# The SEED must be the exact same that was used when compiling the agent
# Garble version 0.5.2 or later must be installed and accessible in the PATH environment variable
windows-garble:
	export GOOS=windows GOARCH=amd64 &&garble -tiny -literals -seed ${SEED} build ${LDFLAGS} -o ${DIR}/merlinServer-Windows-x64.exe main.go

# Compile Server - Linux x64
linux:
	export GOOS=linux && export GOARCH=amd64 && go build ${LDFLAGS} -o ${DIR}/merlinServer-Linux-x64 main.go

# The SEED must be the exact same that was used when compiling the agent
# Garble version 0.5.2 or later must be installed and accessible in the PATH environment variable
linux-garble:
	export GOOS=linux GOARCH=amd64 && garble -tiny -literals -seed ${SEED} build ${LDFLAGS} -o ${DIR}/merlinServer-Linux-x64 main.go

# Compile Server - Darwin x64
darwin:
	export GOOS=darwin && export GOARCH=amd64 && go build ${LDFLAGS} -o ${DIR}/merlinServer-Darwin-x64 main.go

# The SEED must be the exact same that was used when compiling the agent
# Garble version 0.5.2 or later must be installed and accessible in the PATH environment variable
darwin-garble:
	export GOOS=darwin GOARCH=amd64 && garble -tiny -literals -seed ${SEED} build ${LDFLAGS} -o ${DIR}/merlinServer-Darwin-x64.exe main.go

distro: windows linux darwin

clean:
	rm -rf ${DIR}*

=== debian/changelog ===
merlin (2.1.4-0kali1) kali-dev; urgency=medium

  * New upstream version 2.1.4
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 13 May 2025 14:43:42 +0200

merlin (2.1.3-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * d/upstream: Add upstream metadata

  [ Sophie Brun ]
  * New upstream version 2.1.3
  * Refresh patches
  * Use package golang-github-lucas-clemente-quic-go-dev
  * Use default golang-go and add missing (build-)-deps
  * Update build-dep and debian/rules: docs are no longer built with sphinx

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 21 Mar 2025 15:57:13 +0100

merlin (1.5.1+ds-0kali1) kali-dev; urgency=medium

  [ Ben Wilson ]
  * Switch tabs to spaces
  * Fix type mixup
  * Add metapackage to install both

  [ Sophie Brun ]
  * New upstream version 1.5.1+ds
  * Refresh patches
  * Add missing build-deps
  * Add debian/vendor/github.com/lucas-clemente/quic-go
  * Build with go 1.19: required for "old" version of
    github.com/lucas-clemente/quic-go
  * Remove packages prism (obsolete) and merlin-agent (moved to its own repo)
  * Adapt installation for new release
  * Bump Standards-Version to 4.6.2
  * Add package golang-github-ne0nd0g-merlin-dev

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 24 Oct 2023 11:15:39 +0200

merlin (0.10.0~beta+ds-0kali1) kali-dev; urgency=medium

  * Update debian/watch
  * New upstream version 0.10.0~beta+ds
  * Bump Standards-Version to 4.5.1
  * Add missing build-dep golang-github-binject-go-donut-dev

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 30 Mar 2021 12:19:08 +0200

merlin (0.9.1~beta+ds-0kali2) kali-dev; urgency=medium

  * Don't run tests on armhf et armel

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 30 Nov 2020 10:44:45 +0100

merlin (0.9.1~beta+ds-0kali1) kali-dev; urgency=medium

  * Initial release (see 6143)

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 30 Oct 2020 14:33:10 +0100

=== debian/control ===
Source: merlin
Section: misc
Priority: optional
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Sophie Brun <sophie@offensive-security.com>
Build-Depends: debhelper-compat (= 12),
               dh-golang,
               golang-go,
               golang-github-binject-go-donut-dev,
               golang-github-chzyer-readline-dev,
               golang-github-cretz-gopaque-dev,
               golang-github-fatih-color-dev,
	       golang-github-go-jose-go-jose.v3-dev,
               golang-github-lucas-clemente-quic-go-dev,
               golang-github-mattn-go-shellwords-dev,
               golang-github-ne0nd0g-ja3transport-dev,
	       golang-github-ne0nd0g-merlin-message-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-satori-go.uuid-dev,
               golang-go.dedis-kyber-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sync-dev,
               golang-gopkg-square-go-jose.v2-dev,
	       golang-github-cheekybits-genny-dev,
	       golang-github-francoispqt-gojay-dev,
	       golang-github-quic-go-qpack-dev,
	       golang-golang-x-crypto-dev,
	       golang-golang-x-exp-dev,
	       golang-golang-x-net-dev,
	       golang-golang-x-sync-dev,
	       golang-golang-x-sys-dev
Standards-Version: 4.6.2
Vcs-Browser: https://gitlab.com/kalilinux/packages/merlin
Vcs-Git: https://gitlab.com/kalilinux/packages/merlin.git
Homepage: https://github.com/Ne0nd0g/merlin
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/Ne0nd0g/merlin
Testsuite: autopkgtest-pkg-go

Package: merlin
Architecture: any
Section: metapackages
Depends: ${misc:Depends},
         merlin-agent,
         merlin-server,
Description: Command & Control server & agent (metapackage)
 This package contains a cross-platform post-exploitation HTTP/2 Command &
 Control server and agent written in golang as well as an
 identification tool.

Package: merlin-server
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using}
Description: Cross-platform post-exploitation HTTP/2 Command & Control server
 This package contains a cross-platform post-exploitation HTTP/2 Command &
 Control server written in golang.

Package: golang-github-ne0nd0g-merlin-dev
Section: golang
Architecture: all
Depends: golang-github-binject-go-donut-dev,
         golang-github-chzyer-readline-dev,
         golang-github-cretz-gopaque-dev,
         golang-github-fatih-color-dev,
	 golang-github-go-jose-go-jose.v3-dev,
         golang-github-lucas-clemente-quic-go-dev,
         golang-github-mattn-go-shellwords-dev,
         golang-github-ne0nd0g-ja3transport-dev,
	 golang-github-ne0nd0g-merlin-message-dev,
         golang-github-olekukonko-tablewriter-dev,
         golang-github-satori-go.uuid-dev,
         golang-go.dedis-kyber-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-gopkg-square-go-jose.v2-dev,
         golang-github-cheekybits-genny-dev,
         golang-github-francoispqt-gojay-dev,
         golang-github-quic-go-qpack-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-exp-dev,
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
	 ${misc:Depends}
Description: Cross-platform post-exploitation HTTP/2 Command & Control server (source)
 This package contains a cross-platform post-exploitation HTTP/2 Command &
 Control server written in golang.
 .
 This package contains the source go files.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
include /usr/share/dpkg/architecture.mk


%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

execute_after_dh_auto_configure:
	rm -rf $(CURDIR)/_build/src/github.com/marten-seemann
	cp -r $(CURDIR)/debian/vendor/* $(CURDIR)/_build/src/

override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH),armel)
	echo "Do not run test on armel"
else ifeq ($(DEB_HOST_ARCH), armhf)
	echo "Do no run test on armhf"
else
	dh_auto_test
endif

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds\d*$//,\
    repacksuffix=+ds,\
    uversionmangle=s/(\d)[_\.\-\+]?(beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
    https://github.com/Ne0nd0g/merlin/tags .*/v?(\d\S*)\.tar\.gz

## merlin sdk-0.49.0a4

=== Makefile ===
.PHONY: setup
setup:
	@pipenv install --dev --skip-lock

.PHONY: type-check
type-check:
	@pipenv run mypy --ignore-missing-imports --allow-untyped-globals --implicit-optional merlin --follow-imports silent

.PHONY: test
test: type-check
	@pipenv run pytest -n 8 --cov merlin --cov-report xml --cov-report= -W ignore

.PHONY: integration-test
integration-test: type-check
	@pipenv run pytest -n 8 --cov merlin --cov-report xml --cov-report= -m integration -W ignore

.PHONY: integration-test-no-feast
integration-test-no-feast: type-check
	@pipenv run pytest -n 8 --cov merlin --cov-report xml --cov-report= -m "not feast" -W ignore

.PHONY: local-server-test
local-server-test: type-check
	@pipenv run pytest -n 8 --cov merlin --cov-report xml --cov-report= -m local_server_test -W ignore

.PHONY: unit-test
unit-test: type-check
	@pipenv run pytest -n 1 --cov merlin --cov-report xml --cov-report= -m "not integration" -W ignore

=== requirements.txt ===
boto3>=1.35.39
caraml-upi-protos>=0.3.1
certifi>=2017.4.17
Click>=7.0,<8.1.4
cloudpickle==2.0.0  # used by mlflow
cookiecutter>=1.7.2
dataclasses-json>=0.5.2  # allow Flyte version 1.2.0 or above to import Merlin SDK
docker<=6.1.3
GitPython>=3.1.40
google-cloud-storage>=1.19.0
protobuf>=3.12.0,<5.0.0  # Determined by the mlflow dependency
mlflow==1.26.1
PyPrind>=2.11.2
python_dateutil>=2.5.3
PyYAML>=5.4
six>=1.10
urllib3>=1.26
numpy<=1.23.5  # Temporary pin numpy due to https://numpy.org/doc/stable/release/1.20.0-notes.html#numpy-1-20-0-release-notes
caraml-auth-google==0.0.0.post7
pydantic==2.5.3
